// DisplayName = C&C - Renegade

//--- GAME RULES BEGIN ---
// Destroy The Other Team's BASE To Win
// You are provided a base
// MCV's may be excluded on some maps
//--- GAME RULES END ---

// spam fix
function CNCPreBaseGame::AIInit(%game) {
	//call the default AIInit() function
	AIInit();
}

function CNCPreBaseGame::allowsProtectedStatics(%game) {
	return true;
}

function CNCPreBaseGame::assignClientTeam(%game, %client, %respawn) {
      %team1 = $CMDCQR::MCV1Team[""@$CurrentMission@""];
      %team2 = $CMDCQR::MCV2Team[""@$CurrentMission@""];

   %numPlayers = ClientGroup.getCount();
   for(%i = 0; %i <= 6; %i++)
      %numTeamPlayers[%i] = 0;

   for(%i = 0; %i < %numPlayers; %i = %i + 1)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl != %client)
         %numTeamPlayers[%cl.team]++;
   }
   %leastPlayers = %numTeamPlayers[1];
   %leastTeam = 1;
   for(%i = 2; %i <= 6; %i++)
   {
      if( (%numTeamPlayers[%i] < %leastPlayers) ||
         ( (%numTeamPlayers[%i] == %leastPlayers) &&
         ($teamScore[%i] < $teamScore[%leastTeam] ) ))
      {
         if(%i == %team1 || %i == %team2) {
         %leastTeam = %i;
         %leastPlayers = %numTeamPlayers[%i];
         }
         else {
            //not a valid team
         }
      }
   }

   %client.team = %leastTeam;
   %client.lastTeam = %team;
   
   if ( %client.isAIControlled() )
   {
      if ( %leastTeam & 1 )
      {
         %client.skin = addTaggedString( "basebot" );
         setTargetSkin( %client.target, 'basebot' );
      }
      else
      {
         %client.skin = addTaggedString( "basebbot" );
         setTargetSkin( %client.target, 'basebbot' );
      }
   }
   else
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
      //setTargetSkin( %client.target, %client.skin );

   // might as well standardize the messages
   //messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, $teamName[%leastTeam], %client, %leastTeam );
   //messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', $client.name, $teamName[%client.team], %client, %client.team );
   messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
   messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', %client.name, %game.getTeamName(%client.team), %client, %client.team );

   updateCanListenState( %client );

   logEcho(%client.nameBase@" (cl "@%client@") joined team "@%client.team);
}

function CNCPreBaseGame::clientMissionDropReady(%game, %client) {
	CmdCqrGame::clientMissionDropReady(%game, %client);
}

function CNCPreBaseGame::onAIRespawn(%game, %client)
{
   //add the default task
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIPickupItemTask);
	   %client.addTask(AIUseInventoryTask);
	   %client.addTask(AITauntCorpseTask);
		%client.addTask(AIEngageTurretTask);
		%client.addTask(AIDetectMineTask);
		%client.addTask(AIBountyPatrolTask);
		%client.bountyTask = %client.addTask(AIBountyEngageTask);
	}

   //set the inv flag
   %client.spawnUseInv = true;
}

function CNCPreBaseGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement) {
	if (%game.testKill(%clVictim, %clKiller)) { //verify victim was an enemy
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		%game.awardScoreSuicide(%clVictim);
}

function CNCPreBaseGame::awardScoreKill(%game, %killerID)
{
   %killerID.kills++;
   %game.recalcScore(%killerID);
   $TeamScore[%killerID.team] = $TeamScore[%killerID.team] + $CNC::Score[PlayerKill];
}

function CNCPreBaseGame::timeLimitReached(%game) {
	logEcho("game over (timelimit)");
	%game.gameOver();
	cycleMissions();
}

function CNCPreBaseGame::equip(%game, %player) {
   CmdCqrGame::equip(%game, %player);
}

function CNCPreBaseGame::scoreLimitReached(%game) {
	logEcho("game over (scorelimit)");
	%game.gameOver();
	cycleMissions();
}

function CNCPreBaseGame::resetScore(%game, %client) {
   //useless function, but it stops alot of console spam.
}

function CNCPreBaseGame::gameOver(%game) {
    $Game::StopBuild = true;
    $Game::PlayingRene = false;
	CmdCqrGame::gameOver(%game);
}

function CNCPreBaseGame::vehicleDestroyed(%game, %vehicle, %destroyer) {
}

//This will be used soon
function CNCPreBaseGame::pickPlayerSpawn(%game, %client, %respawn)
{
   if(%client.SpawnPoint != -1) {
      //Outpost Died
      if($CNC::OutPostObject[%client.team, %client.SpawnPoint] $= "") {
         %client.SpawnPoint = -1;
         messageClient(%client, 'OutpostDied', '\c1Your Spawn Position (Outpost) Has Been Destroyed, Returning to The MCV.~wfx/misc/warning_beep.wav');
         return %game.pickTeamSpawn(%client.team);
      }
      else {
         %pos = vectorAdd($CNC::OutPostObject[%client.team, %client.SpawnPoint].getPosition(),GetRandomPosition(20,1));
         %pos = vectorAdd(%pos,"0 0 15");
         return %pos;
      }
   }
   else {
   //If not at the outpost.. goto the MCV
      return %game.pickTeamSpawn(%client.team);
   }
}

function CNCPreBaseGame::pickTeamSpawn(%game, %team) {
   CmdCqrGame::pickTeamSpawn(%game, %team);
}

function CNCPreBaseGame::setUpTeams(%game) {
   CmdCqrGame::setUpTeams(%game);
}

function CNCPreBaseGame::startMatch(%game) {
    $Game::StopMCV = false;
    $Game::StopBuild = false;
    //Ensure it reset
	for(%j = 1; %j <= 32; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        $Superweapon::AirstrikeReady[%j] = 0;
        $SuperweaponTimer::Airstrike[%j] = 120;
        cancel(%j.AirSched);
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        if($CNC::EnrichGenerator[%j] !$= "") {
           cancel($CNC::EnrichGenerator[%j].RiftSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        $CNC::EnrichGenerator[%j] = "";
        //Reset outposts
        for(%i = 1; %i < 6; %i++) {
        $CNC::OutPostObject[%j, %i] = "";
        }
        $Building::TeamBuilding[%j] = 0;
        $CNC::TeamOutPostCount[%j] = 0;
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::AABattery[%j] = 0;
        $BuildingCount::NPAGunTurret[%j] = 0;
        $BuildingCount::PECTurret[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::EnrichGenerator[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,AABatTurretBasePack] = 0;
        $TeamDeployedCount[%j,PECTurretBasePack] = 0;
        $TeamDeployedCount[%j,NPATurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,EnrichGeneratorDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $TeamDeployedCount[%j,BuildPadDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
   $Game::PlayingCnC = true;
   $Game::PlayingRene = true;
   $Game::TheGame = %game;

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(isObject(%cl.player)) {
            %moveTo = %game.pickTeamSpawn(%cl.player.team);
            %cl.player.settransform(%moveTo);
            %cl.player.setvelocity("0 0 0");
         }
      }

	DefaultGame::startMatch(%game);
    setSensorGroupCount(7);
   
    //spawn the two MCV's
//    %Team1MCVSpawn = %game.pickTeamSpawn(1);
//    %Team2MCVSpawn = %game.pickTeamSpawn(2);
   //check the map type (Pre-Base (NO MCV), Pre-Base (MCV, ect.)
   if($CNCPB::MCVProvided[""@$CurrentMission@""] == 1) {
      switch($CMDCQR::MCV1Team[""@$CurrentMission@""]) {
         case 1:
            $CCGame::MCV[1] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 1;
                 team = 1;
            };
            WatchMCV($CCGame::MCV[1]);
            setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

         case 2:
            $CCGame::MCV[2] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 2;
                 team = 2;
            };
            WatchMCV($CCGame::MCV[2]);
            setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

         case 3:
            $CCGame::MCV[3] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 3;
                 team = 3;
            };
            WatchMCV($CCGame::MCV[3]);
            setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

         case 4:
            $CCGame::MCV[4] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 4;
                 team = 4;
            };
            WatchMCV($CCGame::MCV[4]);
            setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

         case 5:
            $CCGame::MCV[5] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 5;
                 team = 5;
            };
            WatchMCV($CCGame::MCV[5]);
            setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

         case 6:
            $CCGame::MCV[6] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 6;
                 team = 6;
            };
            WatchMCV($CCGame::MCV[6]);
            setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);
      }
      switch($CMDCQR::MCV2Team[""@$CurrentMission@""]) {
         case 1:
            $CCGame::MCV[1] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
  	             position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 1;
                 team = 1;
            };
            WatchMCV($CCGame::MCV[1]);
            setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

         case 2:
            $CCGame::MCV[2] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 2;
                 team = 2;
            };
            WatchMCV($CCGame::MCV[2]);
            setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

         case 3:
            $CCGame::MCV[3] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 3;
                 team = 3;
            };
            WatchMCV($CCGame::MCV[3]);
            setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

         case 4:
            $CCGame::MCV[4] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 4;
                 team = 4;
            };
            WatchMCV($CCGame::MCV[4]);
            setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

         case 5:
            $CCGame::MCV[5] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 5;
                 team = 5;
            };
            WatchMCV($CCGame::MCV[5]);
            setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

         case 6:
            $CCGame::MCV[6] = new WheeledVehicle()
            {
                 dataBlock  = "MCVVehicle";
	             position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
                 respawn    = "0";
                 teamBought = 6;
                 team = 6;
            };
            WatchMCV($CCGame::MCV[6]);
            setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);
       }
       //SetUpBuildings($CurrentMission);
    }
    //Maps like 'Hall Pass', 'Driven', 'Fogbound', ect.
    else if($CNCPB::MCVProvided[""@$CurrentMission@""] == 0) {
       //SetUpBuildings($CurrentMission);
       //CheckBuildingLoop($CMDCQR::MCV1Team[""@$CurrentMission@""]);
       //CheckBuildingLoop($CMDCQR::MCV2Team[""@$CurrentMission@""]);
    }
}

function SetUpBuildings(%map) {
   %i = 0;
   while($Building[%map,%i] !$= "") {
      $BuildingCount[%map]++;
      %i++;
   }
   echo("C&C: Loading "@$BuildingCount[%map]@" Buildings for "@%map@".");
}

function CheckBuildingLoop(%team) {
   if($Game::StopBuild) {
      echo("C&C: Watch Buildings Stopped.");
      return;
   }
   %pwr = $BuildingCount::PowerPlant[%team];
   %tib = $BuildingCount::TiberiumRefinery[%team];
   %bar = $BuildingCount::Barracks[%team];
   %com = $BuildingCount::CommCenter[%team];
   %agt = $BuildingCount::AdvGuardTurret[%team];
   %ion = $BuildingCount::IonControl[%team];
   %sam = $BuildingCount::SAMTurret[%team];
   %apw = $BuildingCount::AdvPowerPlant[%team];
   %gtw = $BuildingCount::GuardTower[%team];
   %aab = $BuildingCount::AABattery[%team];
   %ntu = $BuildingCount::NPAGunTurret[%team];
   %pec = $BuildingCount::PECTurret[%team];
   %gun = $BuildingCount::GunTurret[%team];
   %obs = $BuildingCount::ObeliskTurret[%team];
   %tem = $BuildingCount::TempOfNod[%team];
   %ein = $BuildingCount::EnrichGenerator[%team];
   %wep = $BuildingCount::WeaponsFactory[%team];
   //heres the if :)
   if(%pwr == 0 && %tib == 0 && %bar == 0 && %com == 0 && %agt == 0 &&
   %ion == 0 && %sam == 0 && %apw == 0 && %gtw = 0 && %aab == 0 &&
   %ntu == 0 && %pec == 0 && %gun == 0 && %obs == 0 && %tem == 0 &&
   %ein == 0 && %wep == 0) {
      $Game::StopBuild = true;
      $Game::TheGame.gameOver();
      cycleMissions();
   }
   schedule(1000,0,"CheckBuildingLoop", %team);
}

function CNCPreBaseGame::leaveMissionArea(%game, %playerData, %player) {
   if(%player.getState() $= "Dead")
      return;
      
   %player.client.outOfBounds = true;
   %player.OutsideKill = schedule(7500,0,"KillOutside", %player);
   messageClient(%player.client, 'LeaveMissionArea', '\c1You left the mission area, Return or be killed.~wfx/misc/warning_beep.wav');

   if(%player.isPilotingMCV == 1) {

      echo("C&C: MCV Left Mission Area, Moving To Spawn");
   
      %obj = $CCGame::MCV[%player.client.team];

      if(%obj.deploySchedule) {
         %obj.deploySchedule.clear();
         %obj.deploySchedule = "";
      }

      if(%obj.deployed !$= "" && %obj.deployed == 1) {
         %obj.setThreadDir($DeployThread, false);
         %obj.playThread($DeployThread,"deploy");
         %obj.playAudio($DeploySound, MobileBaseUndeploySound);

         %obj.shield.open();
         %obj.shield.schedule(1000,"delete");
         %obj.deploySchedule = "";

         %obj.fullyDeployed = 0;
         %obj.noEnemyControl = 0;
      }
      %obj.deployed = 0;

      schedule(1100,0,"DoMCVTeleport",%obj);

      messageClient(%player.client, 'LeaveMissionArea', '\c1MCV outside the mission area, Moving to original spawn.~wfx/misc/warning_beep.wav');
   }
}

function CNCPreBaseGame::clientChangeTeam(%game, %client, %team, %fromObs)
{
//error("DefaultGame::clientChangeTeam");
   //first, remove the client from the team rank array
   //the player will be added to the new team array as soon as he respawns...
   %game.removeFromTeamRankArray(%client);

   %pl = %client.player;
   if(isObject(%pl))
   {
      if(%pl.isMounted())
         %pl.getDataBlock().doDismount(%pl);
      %pl.scriptKill(0);
   }

   // reset the client's targets and tasks only
   clientResetTargets(%client, true);

   // give this client a new handle to disassociate ownership of deployed objects
   if( %team $= "" && (%team > 0 && %team <= 6))
   {
      if(!%client.issuperadmin) {
         if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] )
            %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
         else
            %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
      }
      else {
         if(%client.toNPA) {
            %client.team = 6;
         }
         else {
            if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] ) {
               %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
            }
            else {
               %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
            }
         }
      }
   }
   else {
      %client.team = %team;
      //HA nothing :)
   }

   // Set the client's skin:
   if (!%client.isAIControlled())
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
   setTargetSensorGroup( %client.target, %client.team );
   %client.setSensorGroup( %client.team );

   // Spawn the player:
   %client.lastSpawnPoint = %game.pickPlayerSpawn( %client );

   %game.createPlayer( %client, %client.lastSpawnPoint, $MatchStarted );

   if($MatchStarted)
      %client.setControlObject(%client.player);
   else
   {
      %client.camera.getDataBlock().setMode(%client.camera, "pre-game", %client.player);
      %client.setControlObject(%client.camera);
   }

   // call the onEvent for this game type
   %game.onClientEnterObserverMode(%client);  //Bounty uses this to remove this client from others' hit lists

   if(%fromObs $= "" || !%fromObs)
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 switched to team %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You switched to team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }
   else
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined team %2.', %client.name, %game.getTeamName(%client.team), %client, %team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You joined team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }

   updateCanListenState( %client );

   // MES - switch objective hud lines when client switches teams
   messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
   logEcho(%client.nameBase@" (cl "@%client@") switched to team "@%client.team);
}

function CNCPreBaseGame::enterMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;

   cancel(%player.OutsideKill);
   %player.client.outOfBounds = false;
   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
}
